//+------------------------------------------------------------------+
// Real test = start_03/01/09
//+------------------------------------------------------------------+
//---- input parameters
extern string txt0 ="PRINCIPAL set";
extern int    MagicNumber = 150109;
extern double lots = 0.1;
extern double MinPr =50; //Pips  
extern double sl = 55;  //    Stop loss
extern string txt1 ="ST set"; //Short term 
extern int    p0 = 8; //   
extern int    t0 = 7; //    ( 5 )
extern int    s0 = 5; // Slowing 
extern string txt2 ="LT set"; //Long term 
extern int    p1 = 6;  //   
extern int    t1 = 9;  //    ( 5 )
extern int    s1 = 11; // Slowing 
extern string txt3 ="LT_TF: 1=M15, 2=M30, 3=H1, 4=H4, 5=D1 "; //  TF  
extern double TF_2nd = 4;
//=============================================
bool SinglOpenOrder = false;
//=============================================
static int prevtime0 = 0;
static int prevtime1 = 0;
int TF =0;
double B0,B1,A0,A1,A2;
double STlevel = 23.6;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
switch(TF_2nd)
      {
      case 1: TF=15; break;
      case 2: TF=30; break;
      case 3: TF=60; break;
      case 4: TF=240; break;
      case 5: TF=1440; break;
      default: TF = 0; break;
      }
return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//=============================================  
   if(Time[0] == prevtime0) 
       return(0);
   prevtime0 = Time[0];
   int spread = 3;
//----
   if(IsTradeAllowed()) 
     {
       RefreshRates();
       spread = MarketInfo(Symbol(), MODE_SPREAD);
     } 
   else 
     {
       prevtime0 = Time[1];
       return(0);
     }
//=============================================
   A0 = StochMean(0,  p0, t0,s0,1);
   A1 = StochMean(0,  p0, t0,s0,2);
   A2 = StochMean(0,  p0, t0,s0,3);
   if( iTime(NULL,TF,0) != prevtime1 ) 
         {    
         B0 = StochMean(TF, p1, t1,s1,1);
         B1 = StochMean(TF, p1, t1,s1,2);
         prevtime1 = iTime(NULL,TF,0);
         } 
 //=============  
   int SIGNAL =0;   
   if(A0 > A1 && A1 <= A2 && A1 < STlevel)
                        if ( B0 > B1) SIGNAL = 1;
   if(A0 < A1 && A1 >= A2 && A1 > (100.0 - STlevel))
                        if (B0 < B1) SIGNAL =-1;
Comment("\n","\n","A0- A1 = ", A0 - A1, "\n", "B0 - B1 = ", B0 - B1); 
//if (SIGNAL != 0) Alert("SIGNAL = ", SIGNAL);                   
 //=============================================  
 
   bool NextOpenBuy = true;
   bool NextOpenSell = true;     
   int ticket = -1;
   int total = OrdersTotal();   
//----
   for(int i = total - 1; i >= 0; i--) 
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
           int prevticket = OrderTicket();
           if(OrderType() == OP_BUY) 
             {
               if(Bid <= (OrderOpenPrice() + (MinPr + spread) * Point)) 
                       {  
                          NextOpenBuy = false; // :      .                         
                          continue;            //     
                        } 
               if(Bid > (OrderStopLoss() + (sl * 2  + spread) * Point)) 
                 {               
                   if(SIGNAL < 0) 
                     { // reverse
                       ticket = OrderSend(Symbol(), OP_SELL, lots * 2, Bid, 3, 
                                          Ask + sl * Point, 0, WindowExpertName(), MagicNumber, 0, Red); 
                       Sleep(30000);
                       //----
                       if(ticket < 0) 
                           prevtime0 = Time[1];
                       else 
                           OrderCloseBy(ticket, prevticket, Blue);   
                     } 
                   else 
                     { 
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), Bid - sl * Point, 
                          0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime0 = Time[1];
                         }
                     }
                 }  
             } 
           else 
             {
               if(Ask >= (OrderOpenPrice() - (MinPr + spread) * Point))  
                          {  
                             NextOpenSell = false; // :      .                              
                             continue;             //     
                          } 
               if(Ask < (OrderStopLoss() - (sl * 2 + spread) * Point)) 
                 {
                   if(SIGNAL > 0) 
                     { 
                       ticket = OrderSend(Symbol(), OP_BUY, lots * 2, Ask, 3, 
                                          Bid - sl * Point, 0, WindowExpertName(), MagicNumber, 0, Blue); 
                       Sleep(30000);
                       //----
                       if(ticket < 0) 
                           prevtime0 = Time[1];
                       else 
                           OrderCloseBy(ticket, prevticket, Blue);   
                     } 
                   else 
                     { 
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), Ask + sl * Point, 
                          0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime0 = Time[1];
                         }
                     }
                 }  
             }

   if(SinglOpenOrder) return(0);
         }
     }

   if(NextOpenBuy && SIGNAL > 0) 
     { //long
       ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Bid - sl * Point, 0, WindowExpertName(), 
                          MagicNumber, 0, Blue); 
       //----
       if(ticket < 0) 
         {
           Sleep(30000);
           prevtime0 = Time[1];
         }
     } 
  if(NextOpenSell && SIGNAL < 0)
     { // short
       ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Ask + sl * Point, 0, WindowExpertName(), 
                          MagicNumber, 0, Red); 
       if(ticket < 0) 
         {
           Sleep(30000);
           prevtime0 = Time[1];
         }
     }
//--- exit
   return(0);
  }

//+------------------------------------------------------------------+

double StochMean(int TF, int Period_MIN, int Step, int Slowing, int shift)
{
     int  Period1 = Period_MIN;
     int  Period2 = Period_MIN + Step;
     int  Period3 = Period_MIN + Step * 2;
     int  Period4 = Period_MIN + Step * 3;
     int  Period5 = Period_MIN + Step * 4;
      
	   
     double st1 = iStochastic(NULL, TF, Period1,3,Slowing, MODE_SMA, NULL, MODE_MAIN, shift)* 0.2;
     double st2 = iStochastic(NULL, TF, Period2,3,Slowing, MODE_SMA, NULL, MODE_MAIN, shift)* 0.2;
     double st3 = iStochastic(NULL, TF, Period3,3,Slowing, MODE_SMA, NULL, MODE_MAIN, shift)* 0.2;
     double st4 = iStochastic(NULL, TF, Period4,3,Slowing, MODE_SMA, NULL, MODE_MAIN, shift)* 0.2;
     double st5 = iStochastic(NULL, TF, Period5,3,Slowing, MODE_SMA, NULL, MODE_MAIN, shift)* 0.2;
     double res   = st1 + st2 + st3 + st4 + st5;
return(res);
}     